| Disk ARchive 2.8.1 Full featured and portable backup and archiving tool

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | List of all members
libdar::generic_file Class Referenceabstract
Private

this is the interface class from which all other data transfer classes inherit More...

`#include <generic_file.hpp>`

Inherits libdar::proto_generic_file.

Inherited by , libdar::cache, , libdar::fichier_global, libdar::generic_rsync, libdar::memory_file, libdar::null_file, libdar::pile, , , libdar::sar, and libdar::scrambler.

## Public Types
enum | skippability { skip_backward , skip_forward }

## Public Member Functions
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
| generic_file (generic_file &&ref) noexcept
| move constructor
generic_file & | operator= (const generic_file &ref)
| assignment operator
generic_file & | operator= (generic_file &&ref) noexcept
| move operator
| ~generic_file () noexcept(false)
| virtual destructor,
void | terminate ()
| destructor-like call, except that it is allowed to throw exceptions
bool | operator== (generic_file &ref)
bool | operator!= (generic_file &ref)
gf_mode | get_mode () const
| retreive the openning mode for this object
void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
virtual U_I | read (char *a, U_I size) override
| read data from the generic_file inherited from proto_generic_file
virtual void | write (const char *a, U_I size) override
| write data to the generic_file inherited from proto_generic_file
void | write (const std::string &arg)
| write a string to the generic_file
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual bool | skippable (skippability direction, const infinint &amount)=0
| whether the implementation is able to skip
virtual bool | skip (const infinint &pos)=0
| skip at the absolute position
virtual bool | skip_to_eof ()=0
| skip to the end of file
virtual bool | skip_relative (S_I x)=0
| skip relatively to the current position
virtual bool | truncatable (const infinint &pos) const =0
| whether the implementation is able to truncate to the given position
virtual void | truncate (const infinint &pos)
| truncate file at the given offset
virtual infinint | get_position () const =0
| get the current read/write position
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::proto_generic_file
| proto_generic_file (const proto_generic_file &ref)=default
| copy constructor
| proto_generic_file (proto_generic_file &&ref) noexcept=default
| move constructor
proto_generic_file & | operator= (const proto_generic_file &ref)=default
| assignment operator
proto_generic_file & | operator= (proto_generic_file &&ref) noexcept=default
| move operator
virtual | ~proto_generic_file () noexcept(false)
| virtual destructor

## Protected Member Functions
void | set_mode (gf_mode x)
virtual void | inherited_read_ahead (const infinint &amount)=0
| tells the object that several calls to read() will follow to probably obtain at least the given amount of data
virtual U_I | inherited_read (char *a, U_I size)=0
| implementation of read() operation
virtual void | inherited_write (const char *a, U_I size)=0
| implementation of the write() operation
virtual void | inherited_truncate (const infinint &pos)=0
| truncate file at the give offset
virtual void | inherited_sync_write ()=0
| write down any pending data
virtual void | inherited_flush_read ()=0
| reset internal engine, flush caches in order to read the data at current position
virtual void | inherited_terminate ()=0
| destructor-like call, except that it is allowed to throw exceptions
bool | is_terminated () const

## Private Member Functions
void | enable_crc (bool mode)
U_I | read_crc (char *a, U_I size)
void | write_crc (const char *a, U_I size)
void | destroy ()
void | nullifyptr () noexcept
void | copy_from (const generic_file &ref)
void | move_from (generic_file &&ref) noexcept

## Private Attributes
gf_mode | rw
crc * | checksum
bool | terminated
bool | no_read_ahead
U_I(generic_file::* | active_read )(char *a, U_I size)
void(generic_file::* | active_write )(const char *a, U_I size)

## Detailed Description

this is the interface class from which all other data transfer classes inherit

it provides mainly read and write operations, skip operations and few other functions.

Note
  the read and write method are similar to the read and write system calls except that they never return negative values, but throw exception instead. returning zero means end of generic_file. The call is blocked if no data is available for reading. write returns the number of bytes written, and never make partial writtings. Thus, it is blocked until all bytes are written or occures an exception inconsequences the returned value is always the value of the argument "size".

Definition at line 76 of file generic_file.hpp.

## Member Enumeration Documentation

## ◆ skippability

enum libdar::generic_file::skippability

Definition at line 144 of file generic_file.hpp.

## Constructor & Destructor Documentation

## ◆ generic_file() [1/3]

libdar::generic_file::generic_file | ( | gf_mode | m | ) |
| inline

main constructor

Definition at line 80 of file generic_file.hpp.

## ◆ generic_file() [2/3]

libdar::generic_file::generic_file | ( | const generic_file & | ref | ) |
| inline

copy constructor

Definition at line 83 of file generic_file.hpp.

## ◆ generic_file() [3/3]

libdar::generic_file::generic_file | ( | generic_file && | ref | ) |
| inlinenoexcept

move constructor

Definition at line 86 of file generic_file.hpp.

## ◆ ~generic_file()

libdar::generic_file::~generic_file | ( |  | ) |
| inline

virtual destructor,

Note
  this let inherited destructor to be called even from a generic_file pointer to an inherited class

Definition at line 97 of file generic_file.hpp.

## Member Function Documentation

## ◆ copy_to() [1/2]

virtual void libdar::generic_file::copy_to | ( | generic_file & | ref | ) |
| virtual

copy all data from current position to the object in argument

Reimplemented in libdar::pile.

## ◆ copy_to() [2/2]

virtual void libdar::generic_file::copy_to | ( | generic_file & | ref,
|  | const infinint & | crc_size,
|  | crc *& | value )
| virtual

copy all data from the current position to the object in argument and computes a CRC value of the transmitted data

Parameters

  [in] | ref | defines where to copy the data to
  [in] | crc_size | tell the width of the crc to compute on the copied data
  [out] | value | points to a newly allocated crc object containing the crc value

Note
  value has to be deleted by the caller when no more needed

Reimplemented in libdar::pile.

## ◆ crc_status()

bool libdar::generic_file::crc_status | ( |  | ) | const
| inline

to known whether CRC calculation is activated or not

Definition at line 249 of file generic_file.hpp.

## ◆ diff() [1/2]

bool libdar::generic_file::diff | ( | generic_file & | f,
|  | const infinint & | me_read_ahead,
|  | const infinint & | you_read_ahead,
|  | const infinint & | crc_size,
|  | crc *& | value )

compares the contents with the object in argument

Parameters

  [in] | f | is the file to compare the current object with
  [in] | me_read_ahead | is the amount of data to read ahead from "*this" (0 for no limit, up to end of eof)
  [in] | you_read_ahead | is the amount of data to read ahead from f (0 for no limit, up to end of file
  [in] | crc_size | is the width of the CRC to use for calculation
  [out] | value | is the computed checksum, its value can be used for additional testing if this method returns false (no difference between files). The given checksum has to be set to the expected width by the caller.

Returns
  true if arg differ from "this"

Note
  value has to be deleted by the caller when no more needed
  the more simple operator == method may be prefered to diff() when no crc calculation is required

## ◆ diff() [2/2]

bool libdar::generic_file::diff | ( | generic_file & | f,
|  | const infinint & | me_read_ahead,
|  | const infinint & | you_read_ahead,
|  | const infinint & | crc_size,
|  | crc *& | value,
|  | infinint & | err_offset )

compare the contents with the object in argument, also providing the offset of the first difference met

Parameters

  [in] | f | is the file to compare the current object with
  [in] | me_read_ahead | is the amount of data to read ahead from "*this" (0 for no limit, up to end of eof)
  [in] | you_read_ahead | is the amount of data to read ahead from f (0 for no limit, up to end of file
  [in] | crc_size | is the width of the CRC to use for calculation
  [out] | value | is the computed checksum, its value can be used for additional
  [out] | err_offset | in case of difference, holds the offset of the first difference met testing if this method returns false (no difference between files). The given checksum has to be set to the expected width by the caller.

Returns
  true if arg differ from "this", else false is returned and err_offset is set

Note
  value has to be deleted by the caller when no more needed
  the more simple operator == method may be prefered to diff() when no crc calculation is required

## ◆ get_crc()

crc * libdar::generic_file::get_crc | ( |  | ) |

get CRC of the transfered date since last reset

Returns
  a newly allocated crc object, that the caller has the responsibility to delete

Note
  does also ends checksum calculation, which if needed again have to be re-enabled calling reset_crc() method

## ◆ get_mode()

gf_mode libdar::generic_file::get_mode | ( |  | ) | const
| inline

retreive the openning mode for this object

Definition at line 109 of file generic_file.hpp.

Referenced by libdar::generic_to_global_file::generic_to_global_file(), and libdar::hash_fichier::skip_to_eof().

## ◆ get_position()

virtual infinint libdar::generic_file::get_position | ( |  | ) | const
| pure virtual

get the current read/write position

Implemented in libdar::cache, libdar::cache_global, libdar::compressor, libdar::compressor_zstd, libdar::fichier_local, libdar::generic_rsync, libdar::generic_to_global_file, libdar::hash_fichier, libdar::memory_file, libdar::null_file, libdar::parallel_tronconneuse, libdar::pile, libdar::sar, libdar::scrambler, libdar::trivial_sar, libdar::tronc, libdar::tronconneuse, libdar::tuyau, libdar::tuyau_global, and libdar::zapette.

Referenced by libdar::compressor::get_position(), libdar::compressor_zstd::get_position(), libdar::generic_rsync::get_position(), libdar::generic_to_global_file::get_position(), libdar::hash_fichier::get_position(), libdar::generic_to_global_file::get_size(), and libdar::hash_fichier::skip().

## ◆ ignore_read_ahead()

void libdar::generic_file::ignore_read_ahead | ( | bool | mode | ) |
| inline

ignore read ahead requests

Parameters

  [in] | mode | if set to true read_ahead requests are ignored: inherited_read_ahead() of the inherited class is not called

Note
  read_ahead is useful in multi-thread environement when a slave thread can work in advanced and asynchronously to provide read content to reader thread. However, read_ahead is a waste of CPU cycle for in a single threading model

Definition at line 124 of file generic_file.hpp.

## ◆ inherited_flush_read()

virtual void libdar::generic_file::inherited_flush_read | ( |  | ) |
| protectedpure virtual

reset internal engine, flush caches in order to read the data at current position

Note
  when the object relies on external object or system object to fetch the data from for reading, when a call to (inherited_)flush_read() occurs, the current object must not assume that any previously read data is still valid if it has internal buffers or the like and it should flush them asap. This call must not propagate the flush_read to any other gneric_file object it could rely on

Implemented in libdar::cache, libdar::cache_global, libdar::compressor, libdar::compressor_zstd, libdar::fichier_local, libdar::generic_rsync, libdar::generic_to_global_file, libdar::hash_fichier, libdar::memory_file, libdar::null_file, libdar::parallel_tronconneuse, libdar::pile, libdar::sar, libdar::scrambler, libdar::trivial_sar, libdar::tronc, libdar::tronconneuse, libdar::tuyau, libdar::tuyau_global, and libdar::zapette.

## ◆ inherited_read()

virtual U_I libdar::generic_file::inherited_read | ( | char * | a,
|  | U_I | size )
| protectedpure virtual

implementation of read() operation

Parameters

  [in,out] | a | where to put the data to read
  [in] | size | says how much data to read

Returns
  the exact amount of data read and put into 'a'

Note
  read as much byte as requested, up to end of file stays blocked if not enough data is available and EOF not yet met. May return less data than requested only if EOF as been reached. in other worlds, EOF is reached when returned data is stricly less than the requested data Any problem shall be reported by throwing an exception.

Implemented in libdar::cache, libdar::compressor, libdar::compressor_zstd, libdar::fichier_global, libdar::generic_rsync, libdar::memory_file, libdar::null_file, libdar::parallel_tronconneuse, libdar::pile, libdar::sar, libdar::scrambler, libdar::trivial_sar, libdar::tronc, libdar::tronconneuse, libdar::tuyau, and libdar::zapette.

## ◆ inherited_read_ahead()

virtual void libdar::generic_file::inherited_read_ahead | ( | const infinint & | amount | ) |
| protectedpure virtual

tells the object that several calls to read() will follow to probably obtain at least the given amount of data

Parameters

  [in] | amount | is the maximum expected amount of data that is known to be read

Note
  this call may be implemented as a do-nothing call, its presence is only to allow optimization when possible, like in multi-threaded environment

Implemented in libdar::cache, libdar::cache_global, libdar::compressor, libdar::compressor_zstd, libdar::fichier_local, libdar::generic_rsync, libdar::generic_to_global_file, libdar::hash_fichier, libdar::memory_file, libdar::null_file, libdar::parallel_tronconneuse, libdar::pile, libdar::sar, libdar::scrambler, libdar::trivial_sar, libdar::tronc, libdar::tronconneuse, libdar::tuyau, libdar::tuyau_global, and libdar::zapette.

## ◆ inherited_sync_write()

virtual void libdar::generic_file::inherited_sync_write | ( |  | ) |
| protectedpure virtual

write down any pending data

Note
  called after sanity checks from generic_file::sync_write() this method's role is to write down any data pending for writing in the current object it has not to be propagated to other gneric_file object this object could rely on

Implemented in libdar::cache, libdar::cache_global, libdar::compressor, libdar::compressor_zstd, libdar::fichier_local, libdar::generic_rsync, libdar::generic_to_global_file, libdar::hash_fichier, libdar::memory_file, libdar::null_file, libdar::parallel_tronconneuse, libdar::pile, libdar::sar, libdar::scrambler, libdar::trivial_sar, libdar::tronc, libdar::tronconneuse, libdar::tuyau, libdar::tuyau_global, and libdar::zapette.

## ◆ inherited_terminate()

virtual void libdar::generic_file::inherited_terminate | ( |  | ) |
| protectedpure virtual

destructor-like call, except that it is allowed to throw exceptions

Note
  this method must never be called directly but using terminate() instead, generic_file class manages it to never be called more than once

Implemented in libdar::cache, libdar::cache_global, libdar::compressor, libdar::compressor_zstd, libdar::fichier_local, libdar::generic_rsync, libdar::generic_to_global_file, libdar::hash_fichier, libdar::memory_file, libdar::null_file, libdar::parallel_tronconneuse, libdar::pile, libdar::sar, libdar::scrambler, libdar::trivial_sar, libdar::tronc, libdar::tronconneuse, libdar::tuyau, libdar::tuyau_global, and libdar::zapette.

## ◆ inherited_truncate()

virtual void libdar::generic_file::inherited_truncate | ( | const infinint & | pos | ) |
| protectedpure virtual

truncate file at the give offset

Note
  if pos is greater than the current file size, this call may do nothing (not even enlarging the file)
  this call should always fail on a read-only generic_file
  implementation must throw exception if truncate is not possible for other reason than read/write access mode

Implemented in libdar::cache, libdar::cache_global, libdar::compressor, libdar::compressor_zstd, libdar::fichier_local, libdar::generic_rsync, libdar::generic_to_global_file, libdar::hash_fichier, libdar::memory_file, libdar::null_file, libdar::parallel_tronconneuse, libdar::pile, libdar::sar, libdar::scrambler, libdar::trivial_sar, libdar::tronc, libdar::tronconneuse, libdar::tuyau, libdar::tuyau_global, and libdar::zapette.

## ◆ inherited_write()

virtual void libdar::generic_file::inherited_write | ( | const char * | a,
|  | U_I | size )
| protectedpure virtual

implementation of the write() operation

Parameters

  [in] | a | what data to write
  [in] | size | amount of data to write

Note
  must either write all data or report an error by throwing an exception

Implemented in libdar::cache, libdar::compressor, libdar::compressor_zstd, libdar::fichier_global, libdar::generic_rsync, libdar::memory_file, libdar::null_file, libdar::parallel_tronconneuse, libdar::pile, libdar::sar, libdar::scrambler, libdar::trivial_sar, libdar::tronc, libdar::tronconneuse, libdar::tuyau, and libdar::zapette.

## ◆ is_terminated()

bool libdar::generic_file::is_terminated | ( |  | ) | const
| inlineprotected

is some specific call (skip() & Co.) need to be forbidden when the object has been terminated, one can use this call to check the terminated status

Definition at line 328 of file generic_file.hpp.

Referenced by libdar::memory_file::get_position(), libdar::parallel_tronconneuse::get_position(), libdar::tronconneuse::get_position(), libdar::zapette::get_position(), libdar::trivial_sar::skip_to_eof(), libdar::zapette::skip_to_eof(), libdar::parallel_tronconneuse::write_end_of_file(), and libdar::tronconneuse::write_end_of_file().

## ◆ nullifyptr()

void libdar::generic_file::nullifyptr | ( |  | ) |
| inlineprivatenoexcept

Definition at line 343 of file generic_file.hpp.

## ◆ operator!=()

bool libdar::generic_file::operator!= | ( | generic_file & | ref | ) |
| inline

Definition at line 106 of file generic_file.hpp.

## ◆ operator=() [1/2]

generic_file & libdar::generic_file::operator= | ( | const generic_file & | ref | ) |
| inline

assignment operator

Definition at line 89 of file generic_file.hpp.

Referenced by libdar::tronconneuse::operator=(), and libdar::tronconneuse::operator=().

## ◆ operator=() [2/2]

generic_file & libdar::generic_file::operator= | ( | generic_file && | ref | ) |
| inlinenoexcept

move operator

Definition at line 92 of file generic_file.hpp.

## ◆ operator==()

bool libdar::generic_file::operator== | ( | generic_file & | ref | ) |

compaire the object content (implies skipping and reading)

Note
  this is a more simple method than diff()

## ◆ read()

virtual U_I libdar::generic_file::read | ( | char * | a,
|  | U_I | size )
| overridevirtual

read data from the generic_file inherited from proto_generic_file

Implements libdar::proto_generic_file.

Referenced by libdar::cache_global::fichier_global_inherited_read(), libdar::generic_to_global_file::fichier_global_inherited_read(), line_tools_split_in_words(), and read_forward().

## ◆ read_ahead()

void libdar::generic_file::read_ahead | ( | const infinint & | amount | ) |

read ahead information

Parameters

  [in] | amount | is the expected amount of data the caller will read, if zero is given the object shall prepare as much as possible data for reading until a skip request, write request or a new read_ahead request

Note
  after sanity checks, the protected inherited_read_ahead() method is called

Referenced by libdar::cache_global::inherited_read_ahead(), libdar::compressor::inherited_read_ahead(), libdar::compressor_zstd::inherited_read_ahead(), libdar::hash_fichier::inherited_read_ahead(), libdar::scrambler::inherited_read_ahead(), libdar::trivial_sar::inherited_read_ahead(), and libdar::tuyau_global::inherited_read_ahead().

## ◆ read_forward()

S_I libdar::generic_file::read_forward | ( | char & | a | ) |
| inline

read one char

Definition at line 141 of file generic_file.hpp.

References read().

## ◆ reset_crc()

void libdar::generic_file::reset_crc | ( | const infinint & | width | ) |

reset CRC on read or writen data

Parameters

  [in] | width | is the width to use for the CRC

## ◆ set_mode()

void libdar::generic_file::set_mode | ( | gf_mode | x | ) |
| inlineprotected

Definition at line 266 of file generic_file.hpp.

## ◆ skip()

virtual bool libdar::generic_file::skip | ( | const infinint & | pos | ) |
| pure virtual

skip at the absolute position

Parameters

  [in] | pos | the offset in byte where next read/write operation must start

Returns
  true if operation was successfull and false if the requested position is not valid (after end of file)

Note
  if requested position is not valid the reading/writing cursor must be set to the closest valid position

Implemented in libdar::cache, libdar::cache_global, libdar::compressor, libdar::compressor_zstd, libdar::fichier_local, libdar::generic_rsync, libdar::generic_to_global_file, libdar::hash_fichier, libdar::memory_file, libdar::null_file, libdar::parallel_tronconneuse, libdar::pile, libdar::sar, libdar::scrambler, libdar::trivial_sar, libdar::tronc, libdar::tronconneuse, libdar::tuyau, libdar::tuyau_global, and libdar::zapette.

Referenced by libdar::compressor::skip(), libdar::compressor_zstd::skip(), and libdar::generic_to_global_file::skip().

## ◆ skip_relative()

virtual bool libdar::generic_file::skip_relative | ( | S_I | x | ) |
| pure virtual

skip relatively to the current position

Implemented in libdar::cache, libdar::cache_global, libdar::compressor, libdar::compressor_zstd, libdar::fichier_local, libdar::generic_rsync, libdar::generic_to_global_file, libdar::hash_fichier, libdar::memory_file, libdar::parallel_tronconneuse, libdar::pile, libdar::sar, libdar::scrambler, libdar::trivial_sar, libdar::tronc, libdar::tronconneuse, libdar::tuyau_global, and libdar::zapette.

Referenced by libdar::compressor::skip_relative(), libdar::compressor_zstd::skip_relative(), and libdar::generic_to_global_file::skip_relative().

## ◆ skip_to_eof()

virtual bool libdar::generic_file::skip_to_eof | ( |  | ) |
| pure virtual

skip to the end of file

Implemented in libdar::cache, libdar::cache_global, libdar::compressor, libdar::compressor_zstd, libdar::fichier_local, libdar::generic_rsync, libdar::generic_to_global_file, libdar::hash_fichier, libdar::memory_file, libdar::null_file, libdar::parallel_tronconneuse, libdar::pile, libdar::sar, libdar::scrambler, libdar::trivial_sar, libdar::tronc, libdar::tronconneuse, libdar::tuyau, libdar::tuyau_global, and libdar::zapette.

Referenced by libdar::compressor::skip_to_eof(), libdar::compressor_zstd::skip_to_eof(), libdar::generic_to_global_file::skip_to_eof(), and libdar::trivial_sar::skip_to_eof().

## ◆ skippable()

virtual bool libdar::generic_file::skippable | ( | skippability | direction,
|  | const infinint & | amount )
| pure virtual

whether the implementation is able to skip

Note
  the capability to skip does not mean that skip_relative() or skip() will succeed, but rather that the inherited class implementation does not by construction forbid the requested skip (like inherited class providing a generic_file interface of an anonymous pipe for example)

Implemented in libdar::cache, libdar::cache_global, libdar::compressor, libdar::compressor_zstd, libdar::fichier_local, libdar::generic_rsync, libdar::generic_to_global_file, libdar::hash_fichier, libdar::memory_file, libdar::null_file, libdar::parallel_tronconneuse, libdar::pile, libdar::sar, libdar::scrambler, libdar::trivial_sar, libdar::tronc, libdar::tronconneuse, libdar::tuyau, libdar::tuyau_global, and libdar::zapette.

Referenced by libdar::compressor::skippable(), libdar::compressor_zstd::skippable(), libdar::generic_to_global_file::skippable(), libdar::trivial_sar::skippable(), and libdar::tuyau_global::skippable().

## ◆ truncatable()

virtual bool libdar::generic_file::truncatable | ( | const infinint & | pos | ) | const
| pure virtual

whether the implementation is able to truncate to the given position

Implemented in libdar::cache, libdar::cache_global, libdar::compressor, libdar::compressor_zstd, libdar::fichier_local, libdar::generic_rsync, libdar::generic_to_global_file, libdar::hash_fichier, libdar::memory_file, libdar::null_file, libdar::parallel_tronconneuse, libdar::pile, libdar::sar, libdar::scrambler, libdar::trivial_sar, libdar::tronc, libdar::tronconneuse, libdar::tuyau, libdar::tuyau_global, and libdar::zapette.

Referenced by libdar::compressor::truncatable(), libdar::compressor_zstd::truncatable(), libdar::generic_to_global_file::truncatable(), libdar::trivial_sar::truncatable(), libdar::tronc::truncatable(), and libdar::tuyau_global::truncatable().

## ◆ truncate()

virtual void libdar::generic_file::truncate | ( | const infinint & | pos | ) |
| virtual

truncate file at the given offset

Parameters

  [in] | pos | is the offset of the where to cut the file, in other word the pos - 1 will be the last byte of the file (if its size is greater than 1). If pos is greater than EOF the implementation should not enlarge the file and may even no skip the file to its current eof. Though this request is not considered an error implementation can thus do nothing when asked to truncate after EOF.

Note
  running this call on a read-only object will always yeld an exception
  if current file position is after the point to truncate, implementation has to skip back the current writing offset to the new end of file.
  implementation of backward skippability and truncate operation should be coherent: If its not possible to skip backward it should not be possible to truncate the file to this position. If truncate a file to requested position is not possible, it should not be possible to skip backward to that position. This truncatable() with the skip_backward direction should indicate whether the truncate() action will succeed or generate an exception

Referenced by libdar::cache_global::inherited_truncate(), libdar::generic_to_global_file::inherited_truncate(), libdar::scrambler::inherited_truncate(), libdar::trivial_sar::inherited_truncate(), and libdar::tuyau_global::inherited_truncate().

## ◆ write() [1/2]

virtual void libdar::generic_file::write | ( | const char * | a,
|  | U_I | size )
| overridevirtual

write data to the generic_file inherited from proto_generic_file

Implements libdar::proto_generic_file.

Referenced by libdar::cache_global::fichier_global_inherited_write(), libdar::generic_to_global_file::fichier_global_inherited_write(), and line_tools_split_in_words().

## ◆ write() [2/2]

void libdar::generic_file::write | ( | const std::string & | arg | ) |

write a string to the generic_file

Note
  throws a exception if not all data could be written as expected

## Member Data Documentation

## ◆ active_read

U_I(generic_file::* libdar::generic_file::active_read) (char *a, U_I size)
| private

Definition at line 335 of file generic_file.hpp.

## ◆ active_write

void(generic_file::* libdar::generic_file::active_write) (const char *a, U_I size)
| private

Definition at line 336 of file generic_file.hpp.

## ◆ checksum

crc* libdar::generic_file::checksum
| private

Definition at line 332 of file generic_file.hpp.

## ◆ no_read_ahead

bool libdar::generic_file::no_read_ahead
| private

Definition at line 334 of file generic_file.hpp.

## ◆ rw

gf_mode libdar::generic_file::rw
| private

Definition at line 331 of file generic_file.hpp.

## ◆ terminated

bool libdar::generic_file::terminated
| private

Definition at line 333 of file generic_file.hpp.

The documentation for this class was generated from the following file:

- generic_file.hpp